﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls.DragDrop;
using Telerik.Windows;

namespace DragDropCanvas
{
	public partial class DragDropCanvasPage : UserControl
	{
		public DragDropCanvasPage()
		{
			InitializeComponent();

			Loaded += new RoutedEventHandler(DragDropCanvasPage_Loaded);
		}

		void DragDropCanvasPage_Loaded(object sender, RoutedEventArgs e)
		{
			//Make the image draggable and the canvas a target:
			RadDragAndDropManager.SetAllowDrag(this.image, true);
			RadDragAndDropManager.SetAllowDrop(dropCanvas, true);

			//Sign up for the routed evvents:
			this.dropCanvas.AddHandler(RadDragAndDropManager.DragQueryEvent, new EventHandler<DragDropQueryEventArgs>(OnDragQuery));
			this.dropCanvas.AddHandler(RadDragAndDropManager.DropQueryEvent, new EventHandler<DragDropQueryEventArgs>(OnDropQuery));
		}

		private void OnDragQuery(object sender, DragDropQueryEventArgs e)
		{
			if (e.Options.Status == DragStatus.DragQuery)
			{
				e.QueryResult = true;
				e.Handled = true;
			}

			if (e.Options.Status == DragStatus.DropSourceQuery)
			{
				e.QueryResult = true;
				e.Handled = true;
			}
		}

		private void OnDropQuery(object sender, DragDropQueryEventArgs e)
		{
			if (e.Options.Status == DragStatus.DropDestinationQuery)
			{
				e.QueryResult = true;

				//Move the image:
				var image = e.Options.Source as FrameworkElement;

				//Get where the canvas is located relative to the root:
				var canvasPosition = dropCanvas.TransformToVisual(null).Transform(new Point(0, 0));
				var mousePosition = e.Options.CurrentDragPoint;

				//Move the image accordingly:
				Canvas.SetLeft(image, mousePosition.X - canvasPosition.X - image.ActualWidth / 2);
				Canvas.SetTop(image, mousePosition.Y - canvasPosition.Y - image.ActualHeight / 2);
			}
		}
	}
}
